﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using Xilium.CefGlue;
using System.Drawing;
using System.Drawing.Imaging;

namespace CefGlueScreenshot
{
    internal class CefSimpleBrowser 
    {
        private CefBrowser Browser;
        private IntPtr BrowserWindowHandle;
        public SimpleNativeWindow Window;
        public Bitmap WindowBitmap;

        private string StartUrl = "about:blank";
        
        public CefSimpleBrowser(SimpleNativeWindow window)
        {
            this.Window = window;
            this.BrowserWindowHandle = window.Handle;

            var windowInfo = CefWindowInfo.Create();

            windowInfo.SetAsChild(this.BrowserWindowHandle, new CefRectangle(window.X, window.Y, window.Width, window.Height));
            windowInfo.SetAsOffScreen(this.BrowserWindowHandle);
            windowInfo.TransparentPainting = true;

            var client = new CefSimpleClient(this);

            var settings = new CefBrowserSettings
            {
                // AuthorAndUserStylesDisabled = false,
            };

            this.WindowBitmap = new Bitmap(this.Window.Width, this.Window.Height);

            CefBrowserHost.CreateBrowser(windowInfo, client, settings, this.StartUrl);
        }

        internal void BrowserAfterCreated(CefBrowser browser)
        {
            this.Browser = browser;
        }

        public CefBrowser GetBrowser()
        { 
            return this.Browser; 
        }
    }
}
