﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xilium.CefGlue;

namespace CefGlueScreenshot
{
    class CefSimpleClient : CefClient
    {
        private readonly CefSimpleBrowser Core;
        private readonly CefSimpleLifeSpanHandler LifeSpanHandler;
        private readonly CefSimpleDisplayHandler DisplayHandler;
        private readonly CefSimpleRenderHandler RenderHandler;

        public CefSimpleClient(CefSimpleBrowser core)
        {
            this.Core = core;
            this.LifeSpanHandler = new CefSimpleLifeSpanHandler(this.Core);
            this.DisplayHandler = new CefSimpleDisplayHandler(this.Core);
            this.RenderHandler = new CefSimpleRenderHandler(this.Core);
        }

        protected override CefLifeSpanHandler GetLifeSpanHandler()
        {
            return this.LifeSpanHandler;
        }

        protected override CefDisplayHandler GetDisplayHandler()
        {
            return this.DisplayHandler;
        }

        protected override CefRenderHandler GetRenderHandler()
        {
            return this.RenderHandler;
        }
    }
}
