﻿using Xilium.CefGlue;
using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace CefGlueScreenshot
{
    class CefSimpleRenderHandler : CefRenderHandler
    {
        private readonly CefSimpleBrowser Core;

        public CefSimpleRenderHandler(CefSimpleBrowser core)
        {
            this.Core = core;
        }

        protected override void OnCursorChange(CefBrowser browser, IntPtr cursorHandle)
        {
            ;
        }

        protected override void  OnPopupSize(CefBrowser browser, CefRectangle rect)
        {
            ;
        }

        unsafe protected override void OnPaint(CefBrowser browser, CefPaintElementType type, CefRectangle[] dirtyRects, IntPtr buffer, int width, int height)
        {
            Rectangle rect = new Rectangle(this.Core.Window.X, this.Core.Window.Y, this.Core.Window.Width, this.Core.Window.Height);

            try
            {
                BitmapData ScreenShot = this.Core.WindowBitmap.LockBits(
                   rect, System.Drawing.Imaging.ImageLockMode.WriteOnly,
                   System.Drawing.Imaging.PixelFormat.Format32bppArgb
                );

                int totalSize = ScreenShot.Stride * ScreenShot.Height;

                byte[] TemporaryBuffer = null;

                if ((TemporaryBuffer == null) || (totalSize > TemporaryBuffer.Length))
                    TemporaryBuffer = new byte[totalSize];

                IntPtr screenShotPtr = ScreenShot.Scan0;

                Marshal.Copy(buffer, TemporaryBuffer, 0, totalSize);
                Marshal.Copy(TemporaryBuffer, 0, screenShotPtr, totalSize);

                this.Core.WindowBitmap.UnlockBits(ScreenShot);
            }
            catch(Exception e) { }

        }

        protected override bool GetViewRect(CefBrowser browser, ref CefRectangle rect)
        {
            rect = new CefRectangle(Core.Window.X, Core.Window.Y, Core.Window.Width, Core.Window.Height);
            return true;
        }
    }
}
